#include "DARev.h"

#include "DAInteg.h"

DARev::DARev( int n, int c )
: num( n ), change( c ), isEdited( false )
{
	icount = 0;
	istack = 0x0;
}

DARev::~DARev(void)
{
	DAInteg* next;
	while ( istack )
	{
		next = istack->Next();
		delete istack;
		istack = next;
	}
}

DAInteg* DARev::addInteg( int h, const StrPtr* f, int s, int e )
{
	DAInteg::How how = (DAInteg::How)h;
	//Downgrade "how" if revision was edited.
	if ( isEdited )
	{
		switch( how )
		{
		case DAInteg::Branch:
			how = DAInteg::Add;
			break;
		case DAInteg::Copy:
		case DAInteg::Merge:
		case DAInteg::Ignore:
			how = DAInteg::Edit;
			break;
		}
	}

	icount++;
	istack = new DAInteg( istack );
	istack->Init( (DAInteg::How)how, f, s, e );
	return istack;
}

DAInteg* DARev::getInteg( int i )
{
	if ( i >= icount || i < 0 ) return 0x0;
	DAInteg* integ = istack;
	for ( ; i && integ ; i-- )
	{
		integ = integ->Next();
	}
	return integ;
}

